LeetCode 167:两数之和 II - 输入有序数组 Two Sum II - Input array is sorted

知识共享许可协议 版权声明:署名,允许他人基于本文进行创作,且必须基于与原先许可协议相同的许可协议分发本文 (Creative Commons

公众号:爱写bug(ID:icodebugs)

作者:爱写bug

给定一个已按照升序排列 的有序数组,找到两个数使得它们相加之和等于目标数。

函数应该返回这两个下标值 index1 和 index2,其中 index1 必须小于 index2*。*

说明:

  • 返回的下标值(index1 和 index2)不是从零开始的。
  • 你可以假设每个输入只对应唯一的答案,而且你不可以重复使用相同的元素。

示例:

输入: numbers = [2, 7, 11, 15], target = 9
输出: [1,2]
解释: 2 与 7 之和等于目标数 9 。因此 index1 = 1, index2 = 2 。

Given an array of integers that is already sorted in ascending order, find two numbers such that they add up to a specific target number.

The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2.

Note:

  • Your returned answers (both index1 and index2) are not zero-based.
  • You may assume that each input would have exactly one solution and you may not use the same element twice.

解题思路:

​ 双指针例题的加强版:一个指针从左向右移动,另一个指针从右向左,左指针与右指针之和如果小于 target ,则左指针右移一位,如果大于target ,右指针左移一位,直到双指针之和等于target。

代码(java):

class Solution {
    public int[] twoSum(int[] numbers, int target) {
        int[] res = new int[2];
        int i = 0, j = numbers.length - 1,temp;//i为左指针,j为右指针
        while (i < j) {
            temp=numbers[i] + numbers[j];//先记录两数之和
            if (temp == target) {//等于目标数则记录其索引
                res[0] = i + 1;
                res[1] = j + 1;
                return res;
            } else if (temp < target) {//小于目标数,左指针右移一位
                i++;
            } else {//大于目标数,右指针左移一位
                j--;
            }           
        }
        return null;
    }
}

代码(python3):

class Solution:
    def twoSum(self, numbers: List[int], target: int) -> List[int]:
        i=0
        j=len(numbers)-1
        while i<j:
            if numbers[i]+numbers[j]==target:
                return i+1,j+1
            elif numbers[i]+numbers[j]>target:
                j-=1
            else:i+=1

总结:

这道题本身很简单,几个小细节:

  • if (temp == target) 先判断与目标数是否相同 可减少运行时间(因为Leetcode是拿很多不同数据来运行,而不是一条超长数据。仔细想想这里的区别)
  • temp=numbers[i] + numbers[j] 先把两数之和记录下来,像py3里那种判断两次(==、>)每次都计算一次两数和,会消耗更多时间,这在判断条件增多时会很明显。

扩展:

后面找到py3一种很有意思的解法,就是效率不高,扩展一下思路即可:

class Solution(object):
    def twoSum(self, numbers, target):
        s = {}
        r = []
        for i in range(len(numbers)):
            if numbers[i] in s.keys():#判断该数在s键值对的键中是否存在。因为键值对的键记录的是差值
                r.append(s[numbers[i]]+1)
                r.append(i+1)
                return r
            s[target-numbers[i]] = i#目标数与每一个数差值记录为s键值对的键,其索引记录为值
        return None

利用py3字典特性解题,很有意思。
在这里插入图片描述

猜你喜欢

转载自blog.csdn.net/zkd758/article/details/95329139
今日推荐